#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>


#define BGM_FILE	"thbgm.dat"
#define MAX_BGM		18

int bgmtable[MAX_BGM][3]={
	{0x00000010, 0x003C3830, 0x00E2FA10},
	{0x00E3CDD0, 0x010C5A08, 0x02514210},
	{0x0251F000, 0x0254FAD4, 0x02C95210},
	{0x02C9F510, 0x02D33938, 0x04100E10},
	{0x041061E0, 0x04177E80, 0x052C75F0},
	{0x052CC000, 0x055CB370, 0x07176A10},
	{0x0717EDC0, 0x07320FE0, 0x08A0EF10},
	{0x08A0EF10, 0x08BAF570, 0x0AC61720},
	{0x0AC61730, 0x0ADF4C30, 0x0BA74520},
	{0x0BA74530, 0x0BAF0530, 0x0D937A60},
	{0x0D93DF60, 0x0DBB0760, 0x0F737C20},
	{0x0F737C20, 0x0F950C20, 0x10298D20},
	{0x10298D30, 0x10772D30, 0x11DFDD20},
	{0x11DFDD30, 0x11E62D30, 0x13FBA870},
	{0x13FBA880, 0x14091A80, 0x15CC1EE0},
	{0x15CC1EF0, 0x16464000, 0x16B77040},
	{0x16B77100, 0x17611700, 0x17AA7A00},
	{0x17AA7AA0, 0x17C71B70, 0x18115730},
};

char bgmfile[MAX_BGM][50]={
	"01-󂳂ꂵ_X.wav",
	"02-l_l@` Romantic Fall.wav",
	"03-cPlɎ邩.wav",
	"04-_l̒ʂ蓹@` Darc Road.wav",
	"05-^̃_[NTCh.wav",
	"06-_Xz.wav",
	"07-H열V͓̉@` Candid Friend.wav",
	"08-tH[IutH[@` H߂.wav",
	"09-d̎R@` Mysterious Mountain.wav",
	"10-{̌i.wav",
	"11-M͙RlԂׂ̈.wav",
	"12-䒌̕@` Grave of Being.wav",
	"13-_тÐ@` Suwa Foughten Field.wav",
	"14-n̓AP̍.wav",
	"15-lCeButFCX.wav",
	"16-[̐_.wav",
	"17-_͌b݂̉J~炷@` Sylphid Dream.wav",
	"18-vC[YXRA.wav",
};

void makeheader(char *header,int datasize){
	int i;
	short s;
	memcpy(header,"RIFF",4);
	i = datasize + 36;
	memcpy(header+4,&i,4);
	memcpy(header+8,"WAVEfmt ",8);
	i = 16;
	memcpy(header+16,&i,4);
	s = 1;
	memcpy(header+20,&s,2);
	s = 2;
	memcpy(header+22,&s,2);
	i = 44100;
	memcpy(header+24,&i,4);
	i = 176400;
	memcpy(header+28,&i,4);
	s = 4;
	memcpy(header+32,&s,2);
	s = 16;
	memcpy(header+34,&s,2);
	memcpy(header+36,"data",4);
	i = datasize;
	memcpy(header+40,&i,4);

}

int main(int argc,char *argv[]){
	FILE *datf,*bgmf;
	int i,j,l,k;
	int rep=2;
	int length;
	int fade=0;
	int fadep=0;
	int ts=0;
	int te=MAX_BGM;
	char header[44];
	short buf[44100*2];
	int s,e;
	double d;


	//bgmtable(JnAJԂn_܂ł̒AI_܂ł̒)Ȃ̂
	//ꂼʒuɊZ
//	for(i=0;i<MAX_BGM;i++){
//		bgmtable[i][1]+=bgmtable[i][0];
//		bgmtable[i][2]+=bgmtable[i][0];
//	}

	//argc̃`FbN
	for(i=1;i<argc;i++){
		switch(argv[i][0]){
		case 'f' :
			argv[i]++; fade=atoi(argv[i]); break;
		case 'F' :
			argv[i]++; fade=-atoi(argv[i]); break;
		case 'P' :
		case 'p' :
			argv[i]++; fadep=atoi(argv[i]); break;
		case 'T' :
		case 't' :
			argv[i]++; ts=te=atoi(argv[i]); break;
		default:
			rep=atoi(argv[i]);
		}
	}

	if(rep<1 || rep>10){
		printf("repeat must be 1-10\n");
		return 0;
	}
	if(fade<-30 || fade>30){
		printf("fade must be 0-30\n");
		return 0;
	}
	if(fadep<0 || fadep>3){
		printf("fade pattern must be 0-3\n");
		return 0;
	}
	if(ts<0 || te>MAX_BGM){
		printf("track number must be 1-%d\n", MAX_BGM);
		return 0;
	}


	printf("track=%d-%d , repeat=%d , fade=%d , fade pattern=%d\n",ts+1,te,rep,fade,fadep);
	if(ts) ts--;

	datf=fopen(BGM_FILE,"rb");
	if(datf==NULL){
		printf("%s not found.", BGM_FILE);
		return 0;
	}

	//Jn
	for(i=ts;i<te;i++){

		printf("Create %s ...\n",bgmfile[i]);
		bgmf=fopen(bgmfile[i],"wb");
		length=(bgmtable[i][2]-bgmtable[i][0])+(bgmtable[i][2]-bgmtable[i][1])*(rep-1);
		if(fade<0) length+=(-fade)*44100*4;
		makeheader(header,length);
		fwrite(header,1,44,bgmf);

		//[v
		for(k=0;k<rep;k++){
			//[
			s=bgmtable[i][1];
			if(k==0) s=bgmtable[i][0];

			//I[
			e=bgmtable[i][2];
			if(k==rep-1 && fade>0) e=bgmtable[i][2]-fade*44100*4;

			for(j=s;j<e;j+=44100*4){
				if(j+44100*4>e) l=e-j;
				else l=44100*4;

				fseek(datf,j,SEEK_SET);
				fread(buf,1,l,datf);
				fwrite(buf,1,l,bgmf);
			}
		}

		//tF[hAEg
		if(fade>0){
			//[vI[
			s=bgmtable[i][2]-fade*44100*4;
			e=bgmtable[i][2];
		}
		else if(fade<0){
			//[v[
			s=bgmtable[i][1];
			e=s-fade*44100*4;
		}
		else{
			s=e=0;
		}

		for(j=s;j<e;j+=44100*4){
			if(j+44100*4>e) l=e-j;
			else l=44100*4;

			fseek(datf,j,SEEK_SET);
			fread(buf,1,l,datf);
			for(k=0;k<l/4;k++){
				switch (fadep) {
				case 0 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=pow(0.001,d);
					break;
				case 1 :
					d=1-(float)((j-s)/4+k)/(abs(fade)*44100);
					break;
				case 2 :
					d=(float)((j-s)/4+k)/(abs(fade)*44100);
					d=(pow(0.001,d)+(1-d))/2;
					break;
				case 3 :
					d=(cos(3.1415926535*(float)((j-s)/4+k)/(abs(fade)*44100))+1)/2;
					break;
				}

				buf[2*k]=(short)(buf[2*k]*d);
				buf[2*k+1]=(short)(buf[2*k+1]*d);
			}
			fwrite(buf,1,l,bgmf);
		}

		fclose(bgmf);
	}
	fclose(datf);

	return 0;
}


